(function() {
  var JavascriptPackage, JavascriptSource, Package, Source, debug, finished, _ref, _ref1,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; },
    __slice = [].slice;

  _ref = require('..'), Package = _ref.Package, Source = _ref.Source;

  _ref1 = require('../command'), finished = _ref1.finished, debug = _ref1.debug;

  JavascriptPackage = (function(_super) {

    __extends(JavascriptPackage, _super);

    function JavascriptPackage() {
      JavascriptPackage.__super__.constructor.apply(this, arguments);
    }

    JavascriptPackage.type = 'javascript';

    JavascriptPackage.aliases = ['js'];

    JavascriptPackage.compressedext = '.min.js';

    JavascriptPackage.ext = '.js';

    JavascriptPackage.prototype.requiredModules = function() {
      return __slice.call(JavascriptPackage.__super__.requiredModules.call(this)).concat(['uglify-js']);
    };

    JavascriptPackage.prototype.compressFile = function(original, dest, cb) {
      var compressor;
      compressor = require('uglify-js').uglify != null ? this.compressFileV1 : this.compressFileV2;
      return original.project(dest, compressor, function(err) {
        if (err) {
          cb(err);
        }
        finished('Compressed', original.fullpath);
        return cb();
      });
    };

    JavascriptPackage.prototype.compressFileV1 = function(data, cb) {
      var ast_mangle, ast_squeeze, gen_code, parser, uglify, _ref2;
      _ref2 = require('uglify-js'), parser = _ref2.parser, uglify = _ref2.uglify;
      gen_code = uglify.gen_code, ast_squeeze = uglify.ast_squeeze, ast_mangle = uglify.ast_mangle;
      return cb(null, gen_code(ast_squeeze(parser.parse(data))));
    };

    JavascriptPackage.prototype.compressFileV2 = function(data, cb) {
      var fs, minify;
      minify = require('uglify-js').minify;
      fs = require('fs');
      return require('temp').open({
        suffix: '.js'
      }, function(err, info) {
        if (err != null) {
          throw err;
        }
        fs.write(info.fd, data);
        return fs.close(info.fd, function(err) {
          var out;
          if (err != null) {
            throw err;
          }
          out = minify(info.path);
          return cb(null, out.code);
        });
      });
    };

    return JavascriptPackage;

  })(Package);

  JavascriptSource = (function(_super) {

    __extends(JavascriptSource, _super);

    function JavascriptSource() {
      JavascriptSource.__super__.constructor.apply(this, arguments);
    }

    JavascriptSource.type = 'javascript';

    JavascriptSource.aliases = ['js'];

    JavascriptSource.ext = '.js';

    JavascriptSource.header = /^\/\/\s*import\s+([a-zA-Z0-9_\-\,\.\[\]\{\}\u0022/ ]+)/m;

    return JavascriptSource;

  })(Source);

  Source.extend(JavascriptSource);

  Package.extend(JavascriptPackage);

}).call(this);
