(function() {
  var MustacheSource, Source, cli, embedPrecompTemplate, embedTemplate, _,
    __hasProp = {}.hasOwnProperty,
    __extends = function(child, parent) { for (var key in parent) { if (__hasProp.call(parent, key)) child[key] = parent[key]; } function ctor() { this.constructor = child; } ctor.prototype = parent.prototype; child.prototype = new ctor(); child.__super__ = parent.prototype; return child; };

  _ = require('underscore');

  Source = require('..').Source;

  cli = require('../command');

  embedTemplate = function(global, json) {
    return "(function() { var _JST = this[\"" + global + "\"] = this[\"" + global + "\"] == null ? {\n  __extend: function(obj) {\n    for (var key in obj) if (Object.prototype.hasOwnProperty.call(obj, key)) this[key] = obj[key];\n  }} : this[\"" + global + "\"]; _JST.__extend(" + json + "); }).call(this);";
  };

  embedPrecompTemplate = function(global, json) {
    return "(function() {\n  var _JST = this[\"" + global + "\"] = this[\"" + global + "\"] == null ? {\n    extend: function(obj) {\n      var key, p, _partials, _templates;\n      for (key in obj) {\n        if (!Object.prototype.hasOwnProperty.call(obj, key)) continue; \n        p = ((_partials = this.partials) != null ? _partials : this.partials = {})[key] = obj[key];\n        ((_templates = this.templates) != null ? \n          _templates : this.templates = {})[key] = Mustache.compile(p);\n      }\n    }\n  } : this[\"" + global + "\"]; _JST.extend(" + json + "); }).call(this);";
  };

  MustacheSource = (function(_super) {

    __extends(MustacheSource, _super);

    MustacheSource.type = 'mustache';

    MustacheSource.ext = ['.mustache', '.mu'];

    MustacheSource.header = null;

    function MustacheSource(options) {
      MustacheSource.__super__.constructor.apply(this, arguments);
      _.defaults(options, {
        global: 'JST',
        precompiled: false
      });
      this.global = options.global, this.precompiled = options.precompiled;
    }

    MustacheSource.prototype.compile = function(original, compiled, cb) {
      var compile,
        _this = this;
      compile = function(data, cb2) {
        var embedder, json;
        (json = {})[original.relpath] = data;
        embedder = _this.precompiled ? embedPrecompTemplate : embedTemplate;
        return cb2(null, embedder(_this.global, JSON.stringify(json)));
      };
      return original.project(compiled, compile, function(err) {
        if (err) {
          cb(err);
        }
        cli.finished('Embedded', original.fullpath);
        return cb();
      });
    };

    MustacheSource.prototype.createFile = function(path) {
      var original;
      original = MustacheSource.__super__.createFile.apply(this, arguments);
      this.createCompiledFile(original);
      return original;
    };

    MustacheSource.prototype.createCompiledFile = function(original) {
      var compiled, cpath, opath;
      cpath = (require('../util')).changeext((opath = original.relpath), '.js');
      compiled = this["package"].file(opath, 'javascript', (require('path')).join(this.output, cpath), this);
      compiled.dependOn(original, _.bind(this.compile, this));
      compiled.setImportedPaths(['mustache']);
      compiled.impermanent = true;
      compiled.register();
      return compiled;
    };

    return MustacheSource;

  })(Source);

  Source.extend(exports.MustacheSource = MustacheSource);

}).call(this);
